/*****************************************************************************/
/*	aisa04w.c																 */
/*																			 */
/*	aISA-P04W/H															 */
/*																			 */
/*	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.									 */
/*																			 */
/*	Date 1998/05/01															 */
/*																			 */
/*****************************************************************************/

#include <windows.h>
#include <tchar.h>

#include "aisa04w.h"	// aISA-P04W/H

/*---------- X^eBbN֐ -----------------------------------------------*/
static BOOL Aisa04wGetDllExportFunc();


/*---------- X^eBbNϐ(萔) -----------------------------------------*/
static HMODULE hDLL = NULL;

// DLL GNX|[g֐AhX̊i[ϐ
static FARPROC pAisa04GetVersion;
static FARPROC pAisa04Create;
static FARPROC pAisa04Close;
static FARPROC pAisa04GetResource;
static FARPROC pAisa04InPort;
static FARPROC pAisa04OutPort;
static FARPROC pAisa04GetLastError;


/*****************************************************************************/
/* 	  aisa04.dll[h												 */
/* 	  																 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa04wDllOpen()
{
	if (hDLL != NULL)
		return FALSE;

	hDLL = (HMODULE)LoadLibrary(AISA04_DLL_NAME);
	if (hDLL == NULL)
		return FALSE;

	if (Aisa04wGetDllExportFunc() == FALSE)
	{
		Aisa04wDllClose();	// DLL GNX|[g֐擾ɎŝŁADLL N[Y
		return FALSE;
	}

	return TRUE;
}

/*****************************************************************************/
/* 	  aisa04.dllA[h											 */
/* 	  																 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa04wDllClose()
{
	if (hDLL == NULL)
		return TRUE;

	if (FreeLibrary(hDLL) == TRUE)
	{
		hDLL = NULL;
		return TRUE;
	}

	return FALSE;
}

/*****************************************************************************/
/* 	  aISA-P04W/H DLL,Driver̃o[Wԍ擾						 */
/* 	  pdwDll DLLo[Wԍi[AhX						 */
/*		  pdwDrv Drivero[Wԍi[AhX						 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa04wGetVersion(PDWORD pdwDll, PDWORD pdwDrv)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa04GetVersion)(pdwDll, pdwDrv);
}

/*****************************************************************************/
/* 	  aISA-P04W/H̔Cӂ̃foCX̎gp錾							 */
/* 	  pwLogSlot	 gpfoCXi[AhX						 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa04wCreate(PWORD pwLogSlot)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa04Create)(pwLogSlot);
}

/*****************************************************************************/
/* 	  aISA-P04W/H̔Cӂ̃foCX̎gpJ							 */
/* 	  wLogSlot gpfoCX											 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa04wClose(WORD wLogSlot)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa04Close)(wLogSlot);
}

/*****************************************************************************/
/* 	  wfoCX̃\[X擾									 */
/* 	  wLogSlot ׂfoCX											 */
/*		  pres	   \[Xi[\̂̃AhX					 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa04wGetResource(WORD wLogSlot, PAISA04R pres)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa04GetResource)(wLogSlot, pres);
}

/*****************************************************************************/
/* 	  Cӂ̃|[gf[^										 */
/* 	  wLogSlot ͂foCX											 */
/*		  dwPort   ͂|[g											 */
/*		  pbValue  ̓f[^i[AhX								 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa04wInPort(WORD wLogSlot, DWORD dwPort, PBYTE pbValue)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa04InPort)(wLogSlot, dwPort, pbValue);
}

/*****************************************************************************/
/* 	  Cӂ̃|[gփf[^o										 */
/* 	  wLogSlot o͂foCX											 */
/*		  dwPort   o͂|[g											 */
/*		  bValue   o͂f[^											 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa04wOutPort(WORD wLogSlot, DWORD dwPort, BYTE bValue)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa04OutPort)(wLogSlot, dwPort, bValue);
}

/*****************************************************************************/
/* 	  aISA-P04W/H̃G[R[h											 */
/* 	  wLogSlot	G[foCX								 */
/* ߂l G[R[h														 */
/*****************************************************************************/
DWORD Aisa04wGetLastError(WORD wLogSlot)
{
	if (hDLL == NULL)
		return AISA04_ERR_WRAPDLL;

	return (*pAisa04GetLastError)(wLogSlot);
}

/*---------------------------------------------------------------------------*/
/* 	  DLLGNX|[g֐AhX̎擾									 */
/* 	  																 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*---------------------------------------------------------------------------*/
static BOOL Aisa04wGetDllExportFunc()
{
	// Aisa04GetVersion ̃AhX擾
	pAisa04GetVersion = GetProcAddress(hDLL, _T("Aisa04GetVersion"));
	if (pAisa04GetVersion == NULL)
		return FALSE;

	// Aisa04Create ̃AhX擾
	pAisa04Create = GetProcAddress(hDLL, _T("Aisa04Create"));
	if (pAisa04Create == NULL)
		return FALSE;

	// Aisa04Close ̃AhX擾
	pAisa04Close = GetProcAddress(hDLL, _T("Aisa04Close"));
	if (pAisa04Close == NULL)
		return FALSE;

	// Aisa04GetResource ̃AhX擾
	pAisa04GetResource = GetProcAddress(hDLL, _T("Aisa04GetResource"));
	if (pAisa04GetResource == NULL)
		return FALSE;

	// Aisa04InPort ̃AhX擾
	pAisa04InPort = GetProcAddress(hDLL, _T("Aisa04InPort"));
	if (pAisa04InPort == NULL)
		return FALSE;

	// Aisa04OutPort ̃AhX擾
	pAisa04OutPort = GetProcAddress(hDLL, _T("Aisa04OutPort"));
	if (pAisa04OutPort == NULL)
		return FALSE;

	// Aisa04GetLastError ̃AhX擾
	pAisa04GetLastError = GetProcAddress(hDLL, _T("Aisa04GetLastError"));
	if (pAisa04GetLastError == NULL)
		return FALSE;

	return TRUE;	// SĂ DLL GNX|[g֐AhX擾
}
